package meerkat.voting;

import meerkat.protobuf.Voting.PlaintextBallot;

public class SharedPlaintextBallotMessage {

   private PlaintextBallot m_plaintextBallot;
   private boolean b_writeable = true;

   synchronized void setSharedMessage (PlaintextBallot plaintextBallot)
   {
      while (!b_writeable) {
         try
         {
            wait ();
         }
         catch (InterruptedException e) {}
      }

      m_plaintextBallot = PlaintextBallot.newBuilder(plaintextBallot).build();
      b_writeable = false;
      notifyAll ();
   }

   synchronized PlaintextBallot getSharedMessage ()
   {
      while (b_writeable) {
         try
         {
            wait ();
         }
         catch (InterruptedException e) { }
      }

      b_writeable = true;
      notifyAll ();

      return PlaintextBallot.newBuilder(m_plaintextBallot).build();
   }
}
